stages:
  - build
  - lint
  - sonar

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

build:
  stage: build
  image: maven
  script:
    - chmod +x mvnw
    - ./mvnw package
  artifacts:
    paths:
      - target/demo-0.0.1-SNAPSHOT.jar

lint:
  stage: lint
  image: maven
  dependencies:
    - build
  script:
    - chmod +x mvnw
    - ./mvnw spotbugs:spotbugs

sonar:
  stage: sonar
  image: maven
  dependencies:
    - lint
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - mvn verify sonar:sonar
